VERSION 5.00
Begin VB.Form frmAddIn 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Child Classer"
   ClientHeight    =   3000
   ClientLeft      =   2175
   ClientTop       =   1935
   ClientWidth     =   5400
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3000
   ScaleWidth      =   5400
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdRefresh 
      Caption         =   "&Refresh"
      Height          =   375
      Left            =   4080
      TabIndex        =   12
      Top             =   1080
      Width           =   1215
   End
   Begin VB.CommandButton cmdAbout 
      Caption         =   "&About..."
      Height          =   375
      Left            =   4080
      TabIndex        =   13
      Top             =   1560
      Width           =   1215
   End
   Begin VB.TextBox txtChildClass 
      Height          =   285
      Left            =   1680
      TabIndex        =   3
      Text            =   "CChildClass"
      Top             =   480
      Width           =   2295
   End
   Begin VB.ListBox lstProperties 
      Height          =   960
      ItemData        =   "frmAddIn.frx":0000
      Left            =   1680
      List            =   "frmAddIn.frx":0002
      Sorted          =   -1  'True
      Style           =   1  'Checkbox
      TabIndex        =   8
      Top             =   1920
      Width           =   2295
   End
   Begin VB.ListBox lstMethods 
      Height          =   960
      ItemData        =   "frmAddIn.frx":0004
      Left            =   1680
      List            =   "frmAddIn.frx":0006
      Sorted          =   -1  'True
      Style           =   1  'Checkbox
      TabIndex        =   5
      Top             =   840
      Width           =   2295
   End
   Begin VB.ComboBox cboBaseClass 
      Height          =   315
      Left            =   1680
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   120
      Width           =   2295
   End
   Begin VB.CommandButton CancelButton 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   4080
      TabIndex        =   11
      Top             =   600
      Width           =   1215
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   4080
      TabIndex        =   10
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label Label6 
      Caption         =   "(Check to override && not call base class)"
      Height          =   495
      Left            =   120
      TabIndex        =   9
      Top             =   2160
      Width           =   1455
   End
   Begin VB.Label Label5 
      Caption         =   "(Check to override && not call base class)"
      Height          =   495
      Left            =   120
      TabIndex        =   6
      Top             =   1080
      Width           =   1455
   End
   Begin VB.Label Label4 
      Caption         =   "&Child Class Name:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   480
      Width           =   1455
   End
   Begin VB.Label Label3 
      Caption         =   "&Properties:"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   1920
      Width           =   1455
   End
   Begin VB.Label Label2 
      Caption         =   "&Methods:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   840
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Select a base class:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1575
   End
End
Attribute VB_Name = "frmAddIn"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public VBInstance As VBIDE.VBE
Public Connect As Connect

Option Explicit

Private Sub CancelButton_Click()
    Connect.Hide
End Sub

Private Sub cboBaseClass_Click()
    Dim mem As Member
    Dim i As Integer
    Dim bOK As Boolean
    
    lstMethods.Clear
    lstProperties.Clear
    
    For Each mem In VBInstance.ActiveVBProject.VBComponents(cboBaseClass.Text).CodeModule.Members
        If mem.Scope = vbext_Public Then
            Select Case mem.Type
            Case vbext_mt_Method
                lstMethods.AddItem mem.Name
                
            Case vbext_mt_Property
                bOK = True
                For i = 0 To lstProperties.ListCount - 1
                    If mem.Name = lstProperties.List(i) Then
                        bOK = False
                        Exit For
                    End If
                Next i
                
                If bOK Then lstProperties.AddItem mem.Name
                
            End Select
        End If
    Next mem
End Sub

Private Sub cmdAbout_Click()
    frmAbout.Show vbModal
End Sub

Private Sub cmdRefresh_Click()
    Call Form_Load
End Sub

Private Sub Form_Load()
    Dim cmp As VBComponent
    
    cboBaseClass.Clear
    With VBInstance.ActiveVBProject
        For Each cmp In .VBComponents
            If cmp.Type = vbext_ct_ClassModule Then
                cboBaseClass.AddItem cmp.Name
            End If
        Next cmp
    End With
    
    cboBaseClass.ListIndex = cboBaseClass.ListCount - 1

End Sub

Private Sub OKButton_Click()
    Dim cmp As VBComponent
    Dim l As Long, n As Long
    Dim strBase As String
    Dim line As Long
    Dim strParameters As String
    Dim strLine As String
    Dim strProcName As String
    
    strBase = cboBaseClass.Text
    
    Set cmp = VBInstance.ActiveVBProject.VBComponents.Add(vbext_ct_ClassModule)
    
    On Error Resume Next
        cmp.Name = txtChildClass.Text
        If Err.Number Then
            MsgBox "Error adding class module!" & vbCrLf & "Make sure that it does not already exist.", vbExclamation
            VBInstance.ActiveVBProject.VBComponents.Remove cmp
            Exit Sub
        End If
    On Error GoTo 0
    
    With cmp.CodeModule
        ' Insert Implements line.
        .InsertLines 2, "Implements " & strBase
        
        ' Insert member variable.
        .InsertLines 3, "Private m_Base As " & strBase
        
        ' Insert methods, some of which call base class.
        For l = 0 To lstMethods.ListCount - 1
            line = .CreateEventProc(lstMethods.List(l), strBase)
            
            If lstMethods.Selected(l) Then
                .InsertLines line + 1, "    ' Enter your code to overide this method here..."
            Else
                strLine = .Lines(line, 1)
                strParameters = GetParameters(Mid$(strLine, InStr(1, strLine, "(") + 1, InStrRev(strLine, ")") - InStr(1, strLine, "(") - 1))
                strProcName = strBase & "_" & lstMethods.List(l)
                
                If InStr(1, .Lines(line, 1), "Sub ") Then
                    ' Sub.
                    .InsertLines line + 1, "    Call m_Base." & .Members(strProcName).Name & "(" & strParameters & ")"
                Else
                    ' Function.
                    .InsertLines line + 1, "    " & strProcName & " = m_Base." & lstMethods.List(l) & "(" & strParameters & ")"
                End If
            End If
            
        Next l
        
        ' Insert property members.
        For l = 0 To lstProperties.ListCount - 1
            strProcName = lstProperties.List(l)
            
            With VBInstance.ActiveVBProject.VBComponents(strBase).CodeModule
                If .Find("Property Get " & strProcName, 1, 1, -1, -1) Then
                    line = .ProcBodyLine(strProcName, vbext_pk_Get)
                    strLine = .Lines(line, 1)
                    strLine = Replace$(strLine, "Public ", "Private ", 1, 1)
                    strLine = Replace$(strLine, strProcName, strBase & "_" & strProcName, 1, 1)
                    
                    If lstProperties.Selected(l) Then
                        strLine = strLine & vbCrLf & "    ' Insert you own code here..."
                    Else
                        ' Add the returning code.
                        strLine = strLine & vbCrLf & "    " & strBase & "_" & strProcName & " = m_Base." & strProcName
                    End If
                    
                    ' Add End Property
                    strLine = strLine & vbCrLf & "End Property"
                    
                    cmp.CodeModule.InsertLines cmp.CodeModule.CountOfLines + 1, strLine
                    
                End If
                If .Find("Property Let " & strProcName, 1, 1, -1, -1) Then
                    line = .ProcBodyLine(strProcName, vbext_pk_Let)
                    strLine = .Lines(line, 1)
                    strLine = Replace$(strLine, "Public ", "Private ", 1, 1)
                    strLine = Replace$(strLine, strProcName, strBase & "_" & strProcName, 1, 1)
                    strParameters = GetParameters(Mid$(strLine, InStr(1, strLine, "(") + 1, Len(strLine) - 1))
                    
                    If lstProperties.Selected(l) Then
                        strLine = strLine & vbCrLf & "    ' Insert you own code here..."
                    Else                        ' Set the value to the base class property.
                        strLine = strLine & vbCrLf & "    m_Base." & strProcName & " = "
                        ' Grab 1st parameter.
                        n = InStr(1, strParameters, ",")
                        strLine = strLine & Left$(strParameters, IIf(n = 0, Len(strParameters), n - 1))
                    End If
                    
                    strLine = strLine & vbCrLf & "End Property"
                    
                    cmp.CodeModule.InsertLines cmp.CodeModule.CountOfLines + 1, strLine
                    
                End If
                If .Find("Property Set " & strProcName, 1, 1, -1, -1) Then
                    line = .ProcBodyLine(strProcName, vbext_pk_Set)
                    strLine = .Lines(line, 1)
                    strLine = Replace$(strLine, "Public ", "Private ", 1, 1)
                    strLine = Replace$(strLine, strProcName, strBase & "_" & strProcName, 1, 1)
                    strParameters = GetParameters(Mid$(strLine, InStr(1, strLine, "(") + 1, Len(strLine) - 1))
                    
                    If lstProperties.Selected(l) Then
                        strLine = strLine & vbCrLf & "    ' Insert you own code here..."
                    Else                        ' Set the value to the base class property.
                        strLine = strLine & vbCrLf & "    Set m_Base." & strProcName & " = "
                        ' Grab 1st parameter.
                        n = InStr(1, strParameters, ",")
                        strLine = strLine & Left$(strParameters, IIf(n = 0, Len(strParameters), n - 1))
                    End If
                    
                    strLine = strLine & vbCrLf & "End Property"
                    
                    cmp.CodeModule.InsertLines cmp.CodeModule.CountOfLines + 1, strLine
                    
                End If
            End With
            
        Next l
        
        ' Add class init and terminate.
        .InsertLines .CountOfLines + 1, "Private Sub Class_Initialize()" & vbCrLf & "    Set m_Base = New " & strBase & vbCrLf & "End Sub"
        .InsertLines .CountOfLines + 1, "Private Sub Class_Terminate()" & vbCrLf & "    Set m_Base = Nothing" & vbCrLf & "End Sub"

    End With
    
    cmp.Activate
End Sub

Private Function GetParameters(ByVal strParams As String) As String
    Dim arParam() As String
    Dim strReturn As String
    Dim strTmp As String
    Dim i As Integer
    Dim n As Integer
    
    If strParams = "" Then Exit Function
    strParams = Replace$(strParams, "ByVal ", " ")
    strParams = Replace$(strParams, "ByRef ", " ")
    
    arParam = Split(strParams, ",")
    For i = 0 To UBound(arParam)
        strTmp = Trim$(arParam(i))
        n = InStr(1, strTmp, " ")
        If n = 0 Then
            strReturn = strReturn & strTmp & ", "
        Else
            strReturn = strReturn & Left$(strTmp, n - 1) & ", "
        End If
    Next i
    
    GetParameters = Left$(strReturn, Len(strReturn) - 2)
End Function
